use super::*;

#[derive(Copy, Clone, Debug, Eq, Hash, PartialEq)]
pub enum SyscallNum {
    SysRead = 0,
    SysWrite = 1,
    SysOpen = 2,
    SysClose = 3,
    SysStat = 4,
    SysFstat = 5,
    SysLstat = 6,
    SysPoll = 7,
    SysLseek = 8,
    SysMmap = 9,
    SysMprotect = 10,
    SysMunmap = 11,
    SysBrk = 12,
    SysRtSigaction = 13,
    SysRtSigprocmask = 14,
    SysRtSigreturn = 15,
    SysIoctl = 16,
    SysPread64 = 17,
    SysPwrite64 = 18,
    SysReadv = 19,
    SysWritev = 20,
    SysAccess = 21,
    SysPipe = 22,
    SysSelect = 23,
    SysSchedYield = 24,
    SysMremap = 25,
    SysMsync = 26,
    SysMincore = 27,
    SysMadvise = 28,
    SysShmget = 29,
    SysShmat = 30,
    SysShmctl = 31,
    SysDup = 32,
    SysDup2 = 33,
    SysPause = 34,
    SysNanosleep = 35,
    SysGetitimer = 36,
    SysAlarm = 37,
    SysSetitimer = 38,
    SysGetpid = 39,
    SysSendfile = 40,
    SysSocket = 41,
    SysConnect = 42,
    SysAccept = 43,
    SysSendto = 44,
    SysRecvfrom = 45,
    SysSendmsg = 46,
    SysRecvmsg = 47,
    SysShutdown = 48,
    SysBind = 49,
    SysListen = 50,
    SysGetsockname = 51,
    SysGetpeername = 52,
    SysSocketpair = 53,
    SysSetsockopt = 54,
    SysGetsockopt = 55,
    SysClone = 56,
    SysFork = 57,
    SysVfork = 58,
    SysExecve = 59,
    SysExit = 60,
    SysWait4 = 61,
    SysKill = 62,
    SysUname = 63,
    SysSemget = 64,
    SysSemop = 65,
    SysSemctl = 66,
    SysShmdt = 67,
    SysMsgget = 68,
    SysMsgsnd = 69,
    SysMsgrcv = 70,
    SysMsgctl = 71,
    SysFcntl = 72,
    SysFlock = 73,
    SysFsync = 74,
    SysFdatasync = 75,
    SysTruncate = 76,
    SysFtruncate = 77,
    SysGetdents = 78,
    SysGetcwd = 79,
    SysChdir = 80,
    SysFchdir = 81,
    SysRename = 82,
    SysMkdir = 83,
    SysRmdir = 84,
    SysCreat = 85,
    SysLink = 86,
    SysUnlink = 87,
    SysSymlink = 88,
    SysReadlink = 89,
    SysChmod = 90,
    SysFchmod = 91,
    SysChown = 92,
    SysFchown = 93,
    SysLchown = 94,
    SysUmask = 95,
    SysGettimeofday = 96,
    SysGetrlimit = 97,
    SysGetrusage = 98,
    SysSysInfo = 99,
    SysTimes = 100,
    SysPtrace = 101,
    SysGetuid = 102,
    SysSysLog = 103,
    SysGetgid = 104,
    SysSetuid = 105,
    SysSetgid = 106,
    SysGeteuid = 107,
    SysGetegid = 108,
    SysSetpgid = 109,
    SysGetppid = 110,
    SysGetpgrp = 111,
    SysSetsid = 112,
    SysSetreuid = 113,
    SysSetregid = 114,
    SysGetgroups = 115,
    SysSetgroups = 116,
    SysSetresuid = 117,
    SysGetresuid = 118,
    SysSetresgid = 119,
    SysGetresgid = 120,
    SysGetpgid = 121,
    SysSetfsuid = 122,
    SysSetfsgid = 123,
    SysGetsid = 124,
    SysCapget = 125,
    SysCapset = 126,
    SysRtSigpending = 127,
    SysRtSigtimedwait = 128,
    SysRtSigqueueinfo = 129,
    SysRtSigsuspend = 130,
    SysSigaltstack = 131,
    SysUtime = 132,
    SysMknod = 133,
    SysUselib = 134,
    SysPersonality = 135,
    SysUstat = 136,
    SysStatfs = 137,
    SysFstatfs = 138,
    SysSysFs = 139,
    SysGetpriority = 140,
    SysSetpriority = 141,
    SysSchedSetparam = 142,
    SysSchedGetparam = 143,
    SysSchedSetscheduler = 144,
    SysSchedGetscheduler = 145,
    SysSchedGetPriorityMax = 146,
    SysSchedGetPriorityMin = 147,
    SysSchedRrGetInterval = 148,
    SysMlock = 149,
    SysMunlock = 150,
    SysMlockall = 151,
    SysMunlockall = 152,
    SysVhangup = 153,
    SysModifyLdt = 154,
    SysPivotRoot = 155,
    SysSysCtl = 156,
    SysPrctl = 157,
    SysArchPrctl = 158,
    SysAdjtimex = 159,
    SysSetrlimit = 160,
    SysChroot = 161,
    SysSync = 162,
    SysAcct = 163,
    SysSettimeofday = 164,
    SysMount = 165,
    SysUmount2 = 166,
    SysSwapon = 167,
    SysSwapoff = 168,
    SysReboot = 169,
    SysSethostname = 170,
    SysSetdomainname = 171,
    SysIopl = 172,
    SysIoperm = 173,
    SysCreateModule = 174,
    SysInitModule = 175,
    SysDeleteModule = 176,
    SysGetKernelSyms = 177,
    SysQueryModule = 178,
    SysQuotactl = 179,
    SysNfsservctl = 180,
    SysGetpmsg = 181,
    SysPutpmsg = 182,
    SysAfsSysCall = 183,
    SysTuxcall = 184,
    SysSecurity = 185,
    SysGettid = 186,
    SysReadahead = 187,
    SysSetxattr = 188,
    SysLsetxattr = 189,
    SysFsetxattr = 190,
    SysGetxattr = 191,
    SysLgetxattr = 192,
    SysFgetxattr = 193,
    SysListxattr = 194,
    SysLlistxattr = 195,
    SysFlistxattr = 196,
    SysRemovexattr = 197,
    SysLremovexattr = 198,
    SysFremovexattr = 199,
    SysTkill = 200,
    SysTime = 201,
    SysFutex = 202,
    SysSchedSetaffinity = 203,
    SysSchedGetaffinity = 204,
    SysSetThreadArea = 205,
    SysIoSetup = 206,
    SysIoDestroy = 207,
    SysIoGetevents = 208,
    SysIoSubmit = 209,
    SysIoCancel = 210,
    SysGetThreadArea = 211,
    SysLookupDcookie = 212,
    SysEpollCreate = 213,
    SysEpollCtlOld = 214,
    SysEpollWaitOld = 215,
    SysRemapFilePages = 216,
    SysGetdents64 = 217,
    SysSetTidAddress = 218,
    SysRestartSysCall = 219,
    SysSemtimedop = 220,
    SysFadvise64 = 221,
    SysTimerCreate = 222,
    SysTimerSettime = 223,
    SysTimerGettime = 224,
    SysTimerGetoverrun = 225,
    SysTimerDelete = 226,
    SysClockSettime = 227,
    SysClockGettime = 228,
    SysClockGetres = 229,
    SysClockNanosleep = 230,
    SysExitGroup = 231,
    SysEpollWait = 232,
    SysEpollCtl = 233,
    SysTgkill = 234,
    SysUtimes = 235,
    SysVserver = 236,
    SysMbind = 237,
    SysSetMempolicy = 238,
    SysGetMempolicy = 239,
    SysMqOpen = 240,
    SysMqUnlink = 241,
    SysMqTimedsend = 242,
    SysMqTimedreceive = 243,
    SysMqNotify = 244,
    SysMqGetsetattr = 245,
    SysKexecLoad = 246,
    SysWaitid = 247,
    SysAddKey = 248,
    SysRequestKey = 249,
    SysKeyctl = 250,
    SysIoprioSet = 251,
    SysIoprioGet = 252,
    SysInotifyInit = 253,
    SysInotifyAddWatch = 254,
    SysInotifyRmWatch = 255,
    SysMigratePages = 256,
    SysOpenat = 257,
    SysMkdirat = 258,
    SysMknodat = 259,
    SysFchownat = 260,
    SysFutimesat = 261,
    SysNewfstatat = 262,
    SysUnlinkat = 263,
    SysRenameat = 264,
    SysLinkat = 265,
    SysSymlinkat = 266,
    SysReadlinkat = 267,
    SysFchmodat = 268,
    SysFaccessat = 269,
    SysPselect6 = 270,
    SysPpoll = 271,
    SysUnshare = 272,
    SysSetRobustList = 273,
    SysGetRobustList = 274,
    SysSplice = 275,
    SysTee = 276,
    SysSyncFileRange = 277,
    SysVmsplice = 278,
    SysMovePages = 279,
    SysUtimensat = 280,
    SysEpollPwait = 281,
    SysSignalfd = 282,
    SysTimerfdCreate = 283,
    SysEventfd = 284,
    SysFallocate = 285,
    SysTimerfdSettime = 286,
    SysTimerfdGettime = 287,
    SysAccept4 = 288,
    SysSignalfd4 = 289,
    SysEventfd2 = 290,
    SysEpollCreate1 = 291,
    SysDup3 = 292,
    SysPipe2 = 293,
    SysInotifyInit1 = 294,
    SysPreadv = 295,
    SysPwritev = 296,
    SysRtTgsigqueueinfo = 297,
    SysPerfEventOpen = 298,
    SysRecvmmsg = 299,
    SysFanotifyInit = 300,
    SysFanotifyMark = 301,
    SysPrlimit64 = 302,
    SysNameToHandleAt = 303,
    SysOpenByHandleAt = 304,
    SysClockAdjtime = 305,
    SysSyncfs = 306,
    SysSendmmsg = 307,
    SysSetns = 308,
    SysGetcpu = 309,
    SysProcessVmReadv = 310,
    SysProcessVmWritev = 311,
    SysKcmp = 312,
    SysFinitModule = 313,
    SysSchedSetattr = 314,
    SysSchedGetattr = 315,
    SysRenameat2 = 316,
    SysSeccomp = 317,
    SysGetrandom = 318,
    SysMemfdCreate = 319,
    SysKexecFileLoad = 320,
    SysBpf = 321,
    SysExecveat = 322,
    SysUserfaultfd = 323,
    SysMembarrier = 324,
    SysMlock2 = 325,

    SysSpawn = 360,
}

impl TryFrom<u32> for SyscallNum {
    type Error = error::Error;

    fn try_from(value: u32) -> Result<Self> {
        if value > 325 && value != 360 {
            return_errno!(EINVAL, "invalid syscall number");
        } else {
            Ok(unsafe { core::mem::transmute(value as u16) })
        }
    }
}
